// Lista.h
// parte integral de agenda_ed1.cpp
#include <stdlib.h>
#include <iostream.h>

#ifndef _LISTA_H_
#define _LISTA_H_



class Lista{
private:
        int comp;
        tipo_do_elemento itens[100];
public:
        friend void init(Lista&);
        friend void inserir(Lista&, tipo_do_elemento, int);
        friend tipo_do_elemento eliminar(Lista&, int);
        friend tipo_do_elemento consultar(Lista , int);
        friend void alterar(Lista&, tipo_do_elemento, int);
        friend int vazia(Lista );
        friend int compr (Lista );
        
};

void init(Lista& l)
{
        l.comp=0;
}

void inserir(Lista& l, tipo_do_elemento x, int i)
{
        
        if(l.comp == 100)
        {
                cerr<< "OVERFLOW";
                exit(1);
        }
        else
                if((i <= 0) || (i>l.comp+1))
                {
                        cerr<< "posicao invalida";
                        exit(1);
                }
                else 
                {       
                        if(l.comp >i)
                                for(int k=l.comp; k>=i;k--)
                                        l.itens[k]=l.itens[k-1];
                        l.itens[i-1]=x;
                        l.comp++;
                }
}

tipo_do_elemento eliminar(Lista& l, int i)
{
        tipo_do_elemento x;
        if((i<=0) || (i>l.comp)) 
        {
                cerr<< "posicao invalida ou underflow ";
                exit(1);
        }
        else
        {
                x=l.itens[i-1];
                if(i<l.comp)
                        for ( int k = i; k<=l.comp-1; k++)
                                l.itens[k-1] = l.itens[k];
                l.comp--;
                return x;
        }
}

tipo_do_elemento consultar(Lista l, int i)
{
        if((i<=0) || (i>l.comp)) 
        {
                cerr<< "posicao invalida ou underflow ";
                exit(1);
        }
        else
           return l.itens[i-1];
}

void alterar(Lista& l, tipo_do_elemento x, int i)
{

        if((i<=0) || (i>l.comp)) 
        {
                cerr<< "posicao invalida ou underflow ";
                exit(1);
        }
        else
                l.itens[i-1] = x;
}

int vazia(Lista l)
{
        if(l.comp == 0) return 1;
        else return 0;
}

int compr (Lista l)
{
        return l.comp;
}


#endif